---
title: Create Coupon
slug: api-documentation/create-coupon
docTags: 
createdAt: 2026-08-27T17:06:56.421Z
---

{
  "id": "8pHN_CsjVW-aIzTsWedE9",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/promotion/coupon",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/promotion/coupon"
      }
    ],
    "name": "Create Coupon",
    "description": "<p>This endpoint allows administrators to create a coupon to determine how a promotion may be applied.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>promotion.coupon.create</code></li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        },
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "Sites specified in coupon must match sites of promotion for which the coupon is being created.",
          "customType": "Coupon",
          "schema": [
            {
              "name": "id",
              "kind": "required",
              "type": "string",
              "description": "Unique identifier for the coupon."
            },
            {
              "name": "promotionId",
              "kind": "required",
              "type": "string",
              "description": "Unique identifier for promotion."
            },
            {
              "name": "couponUsages",
              "kind": "required",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/CouponUsage",
              "customType": "CouponUsage[]",
              "schema": [
                {
                  "name": "siteIds",
                  "kind": "required",
                  "type": "array",
                  "description": "Unique identifier for tenant's sites.",
                  "example": "",
                  "itemType": "string",
                  "customType": "string[]",
                  "itemExample": "",
                  "itemDefault": ""
                },
                {
                  "name": "maxUserUsage",
                  "kind": "optional",
                  "type": "integer",
                  "description": ""
                },
                {
                  "name": "maxUsage",
                  "kind": "optional",
                  "type": "integer",
                  "description": ""
                }
              ]
            }
          ],
          "modelRef": "#/components/schemas/Coupon",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "<p>Success-coupon created.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "Coupon",
            "schema": [
              {
                "name": "id",
                "kind": "required",
                "type": "string",
                "description": "Unique identifier for the coupon."
              },
              {
                "name": "promotionId",
                "kind": "required",
                "type": "string",
                "description": "Unique identifier for promotion."
              },
              {
                "name": "couponUsages",
                "kind": "required",
                "type": "array",
                "description": "",
                "modelRef": "#/components/schemas/CouponUsage",
                "customType": "CouponUsage[]",
                "schema": [
                  {
                    "name": "siteIds",
                    "kind": "required",
                    "type": "array",
                    "description": "Unique identifier for tenant's sites.",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "maxUserUsage",
                    "kind": "optional",
                    "type": "integer",
                    "description": ""
                  },
                  {
                    "name": "maxUsage",
                    "kind": "optional",
                    "type": "integer",
                    "description": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/Coupon",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "403",
        "description": "<p>An update to this resource requires the if-match and if-unmodified-since headers to be sent in order to process the request.</p>",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "404",
        "description": "The requested resource was not found in the NoChannel system.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "6hkM3lGnUVtfrA7WHLlb8",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/promotion/coupon \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '{\n     \"id\": \"\",\n     \"promotionId\": \"\",\n     \"couponUsages\": [\n     {\n     \"siteIds\": []\n     }\n     ]\n     }'"
        },
        {
          "id": "RSMjRwl9RVGrdY-a03qHt",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify({\n   \"id\": \"\",\n   \"promotionId\": \"\",\n   \"couponUsages\": [\n      {\n         \"siteIds\": []\n      }\n   ]\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/promotion/coupon\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "EUJ7FCmKXyEsJRQhr3Smq",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/promotion/coupon\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump({\n   \"id\": \"\",\n   \"promotionId\": \"\",\n   \"couponUsages\": [\n      {\n         \"siteIds\": []\n      }\n   ]\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "jJ1_NoKOws-ah_dKQto1H",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/promotion/coupon\"\n\npayload = json.dumps({\n   \"id\": \"\",\n   \"promotionId\": \"\",\n   \"couponUsages\": [\n      {\n         \"siteIds\": []\n      }\n   ]\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "6hkM3lGnUVtfrA7WHLlb8"
    },
    "results": {
      "languages": [
        {
          "id": "C-ArbuTKYW20p0QNMxTRj",
          "language": "201",
          "code": "// Success-coupon created.\n{\n  \"id\": \"\",\n  \"promotionId\": \"\",\n  \"couponUsages\": [\n    {\n      \"siteIds\": [\n        \"\"\n      ],\n      \"maxUserUsage\": 0,\n      \"maxUsage\": 0\n    }\n  ]\n}"
        },
        {
          "id": "Krmt-40_KiVGj7jsd6k7Q",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\"\n}"
        },
        {
          "id": "EpdU0eF0aO8FSJmMwNodP",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "YxI2LbmifCbkv2to-UewN",
          "language": "403",
          "code": "// An update to this resource requires the if-match and if-unmodified-since headers to be sent in order to process the request.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        },
        {
          "id": "TUi5G7dRAObx0Mfp3N8A6",
          "language": "404",
          "code": "// The requested resource was not found in the NoChannel system.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "C-ArbuTKYW20p0QNMxTRj"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}